

class Title{
  String filename;
  String prettyTitle;
  int books[][];
  int films[][];
  float max;
  
  int hue;
  int satu;
  int brightness;
  
  Title(String _t, int _h){
    hue = _h;
    prettyTitle = _t;
    filename = "";
    max = 0;
    // Get filename
    for(int i = 0; i < split(prettyTitle, ' ').length; ++i){
      if (i == 0) {
        filename += split(prettyTitle, ' ')[0].toLowerCase();
      }else{
        String temp = split(prettyTitle, ' ')[i].toLowerCase();
        filename += char(temp.charAt(0)-('a'-'A'))+temp.substring(1);
      }
    }
  
    Table t = loadTable("spl/"+ filename + ".csv", "header");
    
    films = new int[endYear-startYear+1][12];
    books = new int[endYear-startYear+1][12];
    
    for (int i = 0; i < films.length; i++) {
      for (int j = 0; j < films[0].length; j++) {
        books[i][j] = 0;
        films[i][j] = 0;
      }
    }
    
    try{
      for (int i = 0; i < t.getRowCount(); i++) {
        String type = t.getString(i, "Type");
        int month = t.getInt(i, "month");
        int year = t.getInt(i, "year");
        int count = t.getInt(i, "number");
    
        if (type.equals("acbk"))
          books[year-startYear][month-1] += count;
        else if (type.equals("accd") || type.equals("acdvd"))
          films[year-startYear][month-1] += count;
    
        max = max(max, max(books[year-startYear][month-1], 
                           films[year-startYear][month-1]));
      }
    }catch(Exception e){}
    
    
    println(filename + ".csv loaded.");
  }
  
  void setHue(int h, int s, int v){
    hue = h;
    satu = s;
    brightness = v;
  }
  
  void draw(){
    noStroke();
    float centerPadding = 2;
    float barPadding = 0;
    
    float barHeight = titleHeight/(books.length*12) - barPadding;
    float barWidth = titleWidth/2 - 2*centerPadding;
    
    titleWidth = (width - 2*marginHor- (titles.length-1)*padding) / (float)titles.length;
    titleHeight = (height - 2*marginVert);
    
    for (int i = 0; i < books.length; i++) {
      for (int j = 0; j < books[0].length; j++) {
        if(displayMode == 1) {
          // books
          fill(hue, satu, brightness, _map(books[i][j], 0, max, 0, 255));
          rect(0, (i*books[0].length+j)*(barHeight+barPadding), barWidth, barHeight);
          
          // films
          fill(hue, satu, brightness, _map(films[i][j], 0, max, 0, 255));
          rect(barWidth+2*centerPadding, (i*books[0].length+j)*(barHeight+barPadding), barWidth, barHeight);
        }
        else if(displayMode == 2){
          float cellWidth = _map(books[i][j], 0, max, 1, barWidth);
          
          // books
          fill(hue, satu, brightness, _map(books[i][j], 0, max, 0, 255));
          rect(barWidth-cellWidth, (i*books[0].length+j)*(barHeight+barPadding), cellWidth, barHeight);
          
          // films
          cellWidth = _map(films[i][j], 0, max, 1, barWidth);
          fill(hue, satu, brightness, _map(films[i][j], 0, max, 0, 255));
          rect(barWidth+2*centerPadding, (i*books[0].length+j)*(barHeight+barPadding), cellWidth, barHeight);
        }
        else if(displayMode == 3){
          float cellWidth = _map(books[i][j], 0, max, 1, barWidth);
          
          // books
          fill(hue, satu, brightness);
          rect(barWidth-cellWidth, (i*books[0].length+j)*(barHeight+barPadding), cellWidth, barHeight);
          
          // films
          cellWidth = _map(films[i][j], 0, max, 1, barWidth);
          fill(hue, satu, brightness);
          rect(barWidth+2*centerPadding, (i*books[0].length+j)*(barHeight+barPadding), cellWidth, barHeight);
        }
      }
    }
  }
  void drawLabel(){
    textSize(11);
    fill(0,0,72, 190);
    textAlign(CENTER, BOTTOM);
    pushMatrix();
    translate(titleWidth/2, titleHeight);
    rotate(4*PI/2);
    text(prettyTitle, 0,0);
    popMatrix();
  }
  
  private float _map(float val, float x1, float y1, float x2, float y2){
    if (val == 0 || y1 == 0) return 0;
    return isLog ? map(log(val), 0, log(y1), x2, y2) : 
                   map(val, 0, y1, x2, y2);
  }
}